﻿XIncludeFile "!noany.pbi"


DeclareModule CanList
  EnableExplicit
  UseModule NoAny
  
  EnumerationBinary itemstyle

    #ItemStyle_Disabled
  EndEnumeration
  
  ;-declare
  ;-
  Declare _Gadget(*any.integer,x,y,w,h)
  Declare Free(gad)
  
  Declare Clear(gad)
  Declare AddItem(gad,text.s,icon=0,*dat=0,tooltip.s="",style=0)
  Declare FinishItemChange(gad)
  Declare GetState(gad)
  Declare SetState(gad,state)
  Declare.s GetItemText(gad,item)
  Declare GetItemIcon(gad,item)
  Declare GetItemData(gad,item)
  Declare SetItemText(gad,item,text.s)
  Declare SetItemIcon(gad,item,icon)
  Declare SetItemData(gad,item,*data)
  Declare ItemTooltip(gad,item,tooltip.s)
  Declare.s GetText(gad)
  Declare Sort(gad)
  Declare Count(gad)
  Declare Bind(gad,*callback,event)
  
  Macro Gadget(any,x,y,w,h)
    canlist::_Gadget(@any,x,y,w,h)
  EndMacro
  
  Macro SetEvent(a,c)
    CompilerIf Defined(c#_Change,#PB_Procedure)
      CanList::Bind(a,@c#_change(),#PB_EventType_Change)      
    CompilerEndIf
    CompilerIf Defined(c#_LeftClick,#PB_Procedure)
      CanList::Bind(a,@c#_LeftClick(),#PB_EventType_LeftClick)
    CompilerEndIf
    CompilerIf Defined(c#_RightClick,#PB_Procedure)
      CanList::Bind(a,@c#_RightClick(),#PB_EventType_RightClick)
    CompilerEndIf
    CompilerIf Defined(c#_LeftDoubleClick,#PB_Procedure)
      CanList::Bind(a,@c#_LeftDoubleClick(),#PB_EventType_LeftDoubleClick)
    CompilerEndIf
    CompilerIf Defined(c#_RightDoubleClick,#PB_Procedure)
      CanList::Bind(a,@c#_RightDoubleClick(),#PB_EventType_RightDoubleClick)
    CompilerEndIf
  EndMacro
EndDeclareModule


Module CanList
  Global fnt_small
  LoadFont(fnt_small,"Segoe UI",9,#PB_Font_HighQuality)
  
  EnumerationBinary itemstyle
    #ItemStyle_Selected
  EndEnumeration
  
  Structure sItems
    text.s
    icon.i
    *dat
    style.i
    tooltip.s
  EndStructure
  
  Structure sCan
    can_Id.i
    scr_Id.i
    List items.sItems()
    listHight.i
    listPage.i
    listItemHeight.i
    scrollpos.i 
    ignoreResize.i
    SelectedItem.i
    hasFocus.i
    lastTooltip.s
    *bindLeftClick
    *bindLeftDoubleClick
    *bindRightClick
    *bindRightDoubleClick
    *bindChange
  EndStructure  
  
  
    
  
  Procedure _CanList_draw(*dat.sCan)
    Protected w,h
    Protected x,y
    Protected TextH,IconW,IconH
    w=GadgetWidth(*dat\can_Id)
    h=GadgetHeight(*dat\can_Id)
    
    *dat\ignoreResize=#True
    ResizeGadget(*dat\can_Id,#PB_Ignore,#PB_Ignore,w,h); Fix Resize-Output-Bug
   
    If StartDrawing(CanvasOutput(*dat\can_Id))
      DrawingFont(FontID(fnt_small))
      If *dat\listItemHeight=0
        *dat\listItemHeight = TextHeight("Minecraft:Something") + 2
      EndIf
      TextH=*dat\listItemHeight
      
      *dat\listHight=ListSize(*dat\items())-1
      *dat\listPage=(h-4)/TextH
      *dat\scrollpos=GetGadgetState(*dat\scr_Id)
      
      If *dat\scrollpos> *dat\listHight-*dat\listPage+1
        *dat\scrollpos= *dat\listHight-*dat\listPage+1
        If *dat\scrollpos<0
          *dat\scrollpos=0
        EndIf
      EndIf
            
      If *dat\listPage >= *dat\listHight
        HideGadget(*dat\scr_Id,#True)
      Else      
        ResizeGadget(*dat\scr_Id,w-21,1,20,h-2)
        SetGadgetAttribute(*dat\scr_id,#PB_ScrollBar_Maximum,*dat\listHight)
        SetGadgetAttribute(*dat\scr_Id,#PB_ScrollBar_PageLength,*dat\listPage)
        SetGadgetState(*dat\scr_Id,*dat\scrollpos)
        HideGadget(*dat\scr_Id,#False)
      EndIf
      
      Box(0,0,w,h,#White)
      DrawingMode(#PB_2DDrawing_Outlined)
      Box(0,0,w,h,#Black)
      ClipOutput(2,2,w-4,h-4)
      
      y=2 - *dat\scrollpos*TextH
      x=2
      
      ForEach *dat\items()
        If y>h
          Break
        ElseIf y>=2 - TextH 
          
          If *dat\items()\icon
            IconH=TextH
            IconW=TextH * ImageWidth(*dat\items()\icon)/ImageHeight(*dat\items()\icon)
            If IconW>TextH
              IconW=TextH
              IconH=TextH * ImageHeight(*dat\items()\icon)/ImageWidth(*dat\items()\icon)
            EndIf
            DrawingMode(#PB_2DDrawing_AlphaBlend)
            DrawImage(ImageID(*dat\items()\icon),x,y+1,IconW,IconH)
          EndIf
          
          DrawingMode(#PB_2DDrawing_Transparent)
          If *dat\items()\style & #ItemStyle_Disabled            
            Box(x+texth+1,y,w,texth,RGB(240,240,240)) 
            FrontColor(RGB(60,60,60))
          Else
            If ListIndex(*dat\items()) = *dat\SelectedItem
              If *dat\hasFocus
                FrontColor(RGB(60,60,255))
              Else
                FrontColor(RGB(200,200,200))
              EndIf
              Box(x+texth+1,y,w,texth)            
              
              If *dat\hasFocus
                FrontColor(#White)
              Else
                FrontColor(#Black)
              EndIf
            Else
              FrontColor(#Black)
            EndIf          
         
          EndIf
          
          DrawText(x+texth+2,y+1,*dat\items()\text)
          
         
          
          
          
        EndIf
        y+TextH
      Next  
          
      StopDrawing()
    EndIf
      
    *dat\ignoreResize=#False
    
  EndProcedure
  Procedure CanList_Draw()
    _CanList_draw(GetGadgetData(EventGadget()))
  EndProcedure
  
  Procedure ForceInList(*dat.sCan)
    Protected max
    If *dat\SelectedItem>=0
      If *dat\scrollpos>*dat\SelectedItem
        *dat\scrollpos=*dat\SelectedItem
      EndIf
      max=*dat\scrollpos + *dat\listPage-1
      If *dat\SelectedItem>max
        *dat\scrollpos=*dat\SelectedItem - *dat\listPage +1
      EndIf
      SetGadgetState(*dat\scr_Id,*dat\scrollpos)
      _CanList_draw(*dat)
    EndIf
  EndProcedure
  
  Procedure Scr_all()
    Protected *dat.sCan=GetGadgetData(EventGadget())    
    If *dat\ignoreResize=#False
      _CanList_draw(*dat)
    EndIf
  EndProcedure
  Procedure canlist_MouseMove()
    Protected *dat.sCan=GetGadgetData(EventGadget())
    Protected y,pos,tooltip.s
    
    y=GetGadgetAttribute(*dat\can_Id,#PB_Canvas_MouseY)
    pos= ((y-2) /  *dat\listItemHeight) + *dat\scrollpos   
    If pos>=0 And pos < ListSize(*dat\items())
      SelectElement(*dat\items(),pos)
      tooltip=*dat\items()\tooltip
    EndIf
    
    If tooltip<>*dat\lastTooltip
      *dat\lastTooltip=tooltip
      GadgetToolTip(*dat\can_Id,*dat\lastTooltip)
    EndIf
  EndProcedure  
  
  Procedure _CanList_Change(*dat.sCan)
    If *dat\bindChange
      CallFunctionFast(*dat\bindChange)      
    EndIf
    PostEvent(#PB_Event_Gadget,#PB_All,*dat\can_Id,#PB_EventType_Change)
  EndProcedure   
  
  Procedure canlist_leftclick()
    Protected *dat.sCan=GetGadgetData(EventGadget())
    Protected y,pos
    
    y=GetGadgetAttribute(*dat\can_Id,#PB_Canvas_MouseY)
    pos= ((y-2) /  *dat\listItemHeight) + *dat\scrollpos   
    If pos>=0 And pos < ListSize(*dat\items())
      If SelectElement(*dat\items(),pos) And (*dat\items()\style & #ItemStyle_Disabled)=0
        *dat\SelectedItem=pos
        ForceInList(*dat)
      EndIf
    Else 
      *dat\SelectedItem=-1
    EndIf
    _CanList_draw(*dat)
    If *dat\bindLeftClick
      CallFunctionFast(*dat\bindLeftClick)    
    EndIf
    _CanList_Change(*dat)
  EndProcedure
  Procedure CanList_rightclick()
    Protected *dat.sCan=GetGadgetData(EventGadget())
    Protected y,pos
    
    y=GetGadgetAttribute(*dat\can_Id,#PB_Canvas_MouseY)
    pos= ((y-2) /  *dat\listItemHeight) + *dat\scrollpos   
    If pos>=0 And pos < ListSize(*dat\items())
      If SelectElement(*dat\items(),pos) And (*dat\items()\style & #ItemStyle_Disabled)=0
        *dat\SelectedItem=pos
        ForceInList(*dat)
      EndIf
    Else 
      *dat\SelectedItem=-1
    EndIf
    _CanList_draw(*dat)
    If *dat\bindRightClick
      CallFunctionFast(*dat\bindRightClick)
    EndIf
    _CanList_Change(*dat)    
  EndProcedure
  Procedure CanList_rightdoubleclick()
    Protected *dat.sCan=GetGadgetData(EventGadget())
    If *dat\bindRightDoubleClick
      CallFunctionFast(*dat\bindRightDoubleClick)
    EndIf
  EndProcedure
  Procedure CanList_leftdoubleclick()
    Protected *dat.sCan=GetGadgetData(EventGadget())
    If *dat\bindleftDoubleClick
      CallFunctionFast(*dat\bindLeftDoubleClick)
    EndIf
  EndProcedure
  
  Procedure canlist_resize()
    Protected *dat.sCan=GetGadgetData(EventGadget())
    If *dat\ignoreResize=#False
      _CanList_draw(*dat)
    EndIf
  EndProcedure
  Procedure canlist_MouseWheel()
    Protected *dat.sCan=GetGadgetData(EventGadget())
    SetGadgetState(*dat\scr_Id,
                   GetGadgetState(*dat\scr_Id)- GetGadgetAttribute(*dat\can_Id,#PB_Canvas_WheelDelta))
    _CanList_draw(*dat)
  EndProcedure
  Procedure canlist_Focus()
    Protected *dat.sCan=GetGadgetData(EventGadget())
    *dat\HasFocus=#True
    _CanList_draw(*dat)
  EndProcedure
  Procedure canlist_LostFocus()
    Protected *dat.sCan=GetGadgetData(EventGadget())
    *dat\HasFocus=#False
    _CanList_draw(*dat)
  EndProcedure
  Procedure canlist_Input()
    Protected *dat.sCan=GetGadgetData(EventGadget())
    Debug "input:"+GetGadgetAttribute(*dat\can_Id,#PB_Canvas_Key)+" "+GetGadgetAttribute(*dat\can_Id,#PB_Canvas_Input)
  EndProcedure
  
  Procedure canlist_KeyDown()
    Protected *dat.sCan=GetGadgetData(EventGadget())
    Protected ok,max
    Select GetGadgetAttribute(*dat\can_Id,#PB_Canvas_Key)
      Case #PB_Shortcut_Up
        *dat\SelectedItem-1
        ok=#True
      Case #PB_Shortcut_PageUp
        If *dat\SelectedItem = *dat\scrollpos
          *dat\SelectedItem - *dat\listPage
        Else
          *dat\SelectedItem=*dat\scrollpos
        EndIf
        ok=#True
      Case #PB_Shortcut_Down
        *dat\SelectedItem+1
        ok=#True
      Case #PB_Shortcut_PageDown
        max=*dat\scrollpos + *dat\listPage-1
        If *dat\SelectedItem=max
          *dat\SelectedItem + *dat\listPage
        Else
          *dat\SelectedItem=max
        EndIf
        ok=#True
    EndSelect
    If ok
      If *dat\SelectedItem<0
        *dat\SelectedItem=0
      ElseIf *dat\SelectedItem => ListSize(*dat\items())
        *dat\SelectedItem = ListSize(*dat\items())-1
      EndIf
      ForceInList(*dat)
      _CanList_draw(*dat)
      _CanList_Change(*dat)
    EndIf
  EndProcedure
  
  ;-
  ;- Public Gadget
  ;-
  
  Procedure Bind(gad,*callback,event)
    Protected *dat.sCan=GetGadgetData(gad)    
    Select event
      Case #PB_EventType_Change
        *dat\bindChange=*callback
      Case #PB_EventType_LeftClick
        *dat\bindLeftClick=*callback
      Case #PB_EventType_RightClick
        *dat\bindRightClick=*callback
      Case #PB_EventType_LeftDoubleClick
        *dat\bindLeftDoubleClick=*callback
      Case #PB_EventType_RightDoubleClick
        *dat\bindRightDoubleClick=*callback
    EndSelect
  EndProcedure
    
  Procedure GetState(gad)
    Protected *dat.sCan=GetGadgetData(gad)
    ProcedureReturn *dat\SelectedItem
  EndProcedure
  Procedure SetState(gad,state)
    Protected *dat.sCan=GetGadgetData(gad)
    *dat\SelectedItem=state
    _CanList_draw(*dat)
  EndProcedure
  Procedure.s GetItemText(gad,item)
    Protected *dat.sCan=GetGadgetData(gad)
    If SelectElement(*dat\items(),item)
      ProcedureReturn *dat\items()\text
    EndIf
    ProcedureReturn ""
  EndProcedure
  Procedure GetItemIcon(gad,item)
    Protected *dat.sCan=GetGadgetData(gad)
    If SelectElement(*dat\items(),item)
      ProcedureReturn *dat\items()\icon
    EndIf
    ProcedureReturn 0
  EndProcedure
  Procedure GetItemData(gad,item)
    Protected *dat.sCan=GetGadgetData(gad)
    If SelectElement(*dat\items(),item)
      ProcedureReturn *dat\items()\dat
    EndIf
    ProcedureReturn 0
  EndProcedure  
  Procedure SetItemText(gad,item,text.s)
    Protected *dat.sCan=GetGadgetData(gad)
    If SelectElement(*dat\items(),item)
      *dat\items()\text=text
    EndIf
  EndProcedure  
  Procedure SetItemIcon(gad,item,icon)
    Protected *dat.sCan=GetGadgetData(gad)
    If SelectElement(*dat\items(),item)
      *dat\items()\icon=icon
    EndIf
  EndProcedure  
  Procedure SetItemData(gad,item,*data)
    Protected *dat.sCan=GetGadgetData(gad)
    If SelectElement(*dat\items(),item)
      *dat\items()\dat=*data
    EndIf
  EndProcedure  
  
  Procedure Clear(gad)
    Protected *dat.sCan=GetGadgetData(gad)
    ClearList(*dat\items())
    *dat\SelectedItem=-1
    SetGadgetState(*dat\scr_Id,0)    
  EndProcedure
  Procedure AddItem(gad,text.s,icon=0,*gaddat=0,tooltip.s="",style=0)
    Protected *dat.sCan=GetGadgetData(gad)
    LastElement(*dat\items())
    AddElement(*dat\items())
    *dat\items()\text=text
    *dat\items()\icon=icon
    *dat\items()\dat=*gaddat
    *dat\items()\tooltip=Tooltip
    *dat\items()\style=style
  EndProcedure
  Procedure FinishItemChange(gad)
    Protected *dat.sCan=GetGadgetData(gad)
    _CanList_draw(*dat)
  EndProcedure
  Procedure ItemTooltip(gad,item,text.s)
    Protected *dat.sCan=GetGadgetData(gad)
    If SelectElement(*dat\items(),item)
      *dat\items()\tooltip=text
    EndIf
  EndProcedure    
  Procedure.s GetText(gad)
    Protected *dat.sCan=GetGadgetData(gad)
    If *dat\SelectedItem>=0 And SelectElement(*dat\items(),*dat\SelectedItem)
      ProcedureReturn *dat\items()\text
    EndIf
  EndProcedure
  Procedure Sort(gad)
    Protected *dat.sCan=GetGadgetData(gad)
    Protected str.s
    
    If *dat\SelectedItem>=0 And SelectElement(*dat\items(),*dat\SelectedItem)
      *dat\items()\style | #itemstyle_selected
    EndIf    
    
    SortStructuredList(*dat\items(),#PB_Sort_Ascending,OffsetOf(sItems\text),#PB_String)
    
    ForEach *dat\items()
      If *dat\items()\style & #itemstyle_selected
        *dat\items()\style & ~#itemstyle_selected
        *dat\SelectedItem=ListIndex(*dat\items())
      EndIf
    Next
    
    If *dat\SelectedItem>-1
      ForceInList(*dat)
    EndIf
    
    _CanList_draw(*dat)
  EndProcedure
  Procedure count(gad)
    Protected *dat.sCan=GetGadgetData(gad)
    ProcedureReturn ListSize(*dat\items())
  EndProcedure
    
  Procedure _Gadget(*any.integer,x,y,w,h)
    Protected *dat.sCan    
    *dat=AllocateStructure(sCan)
    
    CanvasGadget_noEvent(*dat\can_id,x,y,w,h,#PB_Canvas_Container |#PB_Canvas_Keyboard  )
    ScrollBarGadget_noEvent(*dat\scr_Id,x,y,20,h,0,100,1,#PB_ScrollBar_Vertical)
    CloseGadgetList()
    
    SetGadgetData(*dat\can_Id,*dat)
    SetGadgetData(*dat\scr_Id,*dat)
    SetGadgetEvent(*dat\can_id,CanList)
    SetGadgetEvent(*dat\scr_Id,Scr)
    
    *dat\SelectedItem=-1
    
    _CanList_draw(*dat)
    
    *any\i=*dat\can_Id
    ProcedureReturn *dat\can_id
      
  EndProcedure
  Procedure Free(gad)
    Protected *dat.sCan=GetGadgetData(gad)
    FreeGadget(*dat\scr_Id)
    FreeGadget(*dat\can_Id)
    FreeStructure(*dat)
  EndProcedure
  
  
    
EndModule

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 329
; FirstLine = 318
; Folding = -------
; EnableXP